| # A Swagger 2.0 (a.k.a. OpenAPI) definition of the Engine API. | |
| # | |
| # This is used for generating API documentation and the types used by the | |
| # client/server. See api/README.md for more information. | |
| # | |
| # Some style notes: | |
| # - This file is used by ReDoc, which allows GitHub Flavored Markdown in | |
| # descriptions. | |
| # - There is no maximum line length, for ease of editing and pretty diffs. | |
| # - operationIds are in the format "NounVerb", with a singular noun. | |
| swagger: "2.0" | |
| schemes: | |
| - "http" | |
| - "https" | |
| produces: | |
| - "application/json" | |
| - "text/plain" | |
| consumes: | |
| - "application/json" | |
| - "text/plain" | |
| basePath: "/v1.43" | |
| info: | |
| title: "Docker Engine API" | |
| version: "1.43" | |
| x-logo: | |
| url: "https://docs.docker.com/assets/images/logo-docker-main.png" | |
| description: | | |
| The Engine API is an HTTP API served by Docker Engine. It is the API the | |
| Docker client uses to communicate with the Engine, so everything the Docker | |
| client can do can be done with the API. | |
| Most of the client's commands map directly to API endpoints (e.g. `docker ps` | |
| is `GET /containers/json`). The notable exception is running containers, | |
| which consists of several API calls. | |
| # Errors | |
| The API uses standard HTTP status codes to indicate the success or failure | |
| of the API call. The body of the response will be JSON in the following | |
| format: | |
| ``` | |
| { | |
| "message": "page not found" | |
| } | |
| ``` | |
| # Versioning | |
| The API is usually changed in each release, so API calls are versioned to | |
| ensure that clients don't break. To lock to a specific version of the API, | |
| you prefix the URL with its version, for example, call `/v1.30/info` to use | |
| the v1.30 version of the `/info` endpoint. If the API version specified in | |
| the URL is not supported by the daemon, a HTTP `400 Bad Request` error message | |
| is returned. | |
| If you omit the version-prefix, the current version of the API (v1.43) is used. | |
| For example, calling `/info` is the same as calling `/v1.43/info`. Using the | |
| API without a version-prefix is deprecated and will be removed in a future release. | |
| Engine releases in the near future should support this version of the API, | |
| so your client will continue to work even if it is talking to a newer Engine. | |
| The API uses an open schema model, which means server may add extra properties | |
| to responses. Likewise, the server will ignore any extra query parameters and | |
| request body properties. When you write clients, you need to ignore additional | |
| properties in responses to ensure they do not break when talking to newer | |
| daemons. | |
| # Authentication | |
| Authentication for registries is handled client side. The client has to send | |
| authentication details to various endpoints that need to communicate with | |
| registries, such as `POST /images/(name)/push`. These are sent as | |
| `X-Registry-Auth` header as a [base64url encoded](https://tools.ietf.org/html/rfc4648#section-5) | |
| (JSON) string with the following structure: | |
| ``` | |
| { | |
| "username": "string", | |
| "password": "string", | |
| "email": "string", | |
| "serveraddress": "string" | |
| } | |
| ``` | |
| The `serveraddress` is a domain/IP without a protocol. Throughout this | |
| structure, double quotes are required. | |
| If you have already got an identity token from the [`/auth` endpoint](#operation/SystemAuth), | |
| you can just pass this instead of credentials: | |
| ``` | |
| { | |
| "identitytoken": "9cbaf023786cd7..." | |
| } | |
| ``` | |
| # The tags on paths define the menu sections in the ReDoc documentation, so | |
| # the usage of tags must make sense for that: | |
| # - They should be singular, not plural. | |
| # - There should not be too many tags, or the menu becomes unwieldy. For | |
| # example, it is preferable to add a path to the "System" tag instead of | |
| # creating a tag with a single path in it. | |
| # - The order of tags in this list defines the order in the menu. | |
| tags: | |
| # Primary objects | |
| - name: "Container" | |
| x-displayName: "Containers" | |
| description: | | |
| Create and manage containers. | |
| - name: "Image" | |
| x-displayName: "Images" | |
| - name: "Network" | |
| x-displayName: "Networks" | |
| description: | | |
| Networks are user-defined networks that containers can be attached to. | |
| See the [networking documentation](https://docs.docker.com/network/) | |
| for more information. | |
| - name: "Volume" | |
| x-displayName: "Volumes" | |
| description: | | |
| Create and manage persistent storage that can be attached to containers. | |
| - name: "Exec" | |
| x-displayName: "Exec" | |
| description: | | |
| Run new commands inside running containers. Refer to the | |
| [command-line reference](https://docs.docker.com/engine/reference/commandline/exec/) | |
| for more information. | |
| To exec a command in a container, you first need to create an exec instance, | |
| then start it. These two API endpoints are wrapped up in a single command-line | |
| command, `docker exec`. | |
| # Swarm things | |
| - name: "Swarm" | |
| x-displayName: "Swarm" | |
| description: | | |
| Engines can be clustered together in a swarm. Refer to the | |
| [swarm mode documentation](https://docs.docker.com/engine/swarm/) | |
| for more information. | |
| - name: "Node" | |
| x-displayName: "Nodes" | |
| description: | | |
| Nodes are instances of the Engine participating in a swarm. Swarm mode | |
| must be enabled for these endpoints to work. | |
| - name: "Service" | |
| x-displayName: "Services" | |
| description: | | |
| Services are the definitions of tasks to run on a swarm. Swarm mode must | |
| be enabled for these endpoints to work. | |
| - name: "Task" | |
| x-displayName: "Tasks" | |
| description: | | |
| A task is a container running on a swarm. It is the atomic scheduling unit | |
| of swarm. Swarm mode must be enabled for these endpoints to work. | |
| - name: "Secret" | |
| x-displayName: "Secrets" | |
| description: | | |
| Secrets are sensitive data that can be used by services. Swarm mode must | |
| be enabled for these endpoints to work. | |
| - name: "Config" | |
| x-displayName: "Configs" | |
| description: | | |
| Configs are application configurations that can be used by services. Swarm | |
| mode must be enabled for these endpoints to work. | |
| # System things | |
| - name: "Plugin" | |
| x-displayName: "Plugins" | |
| - name: "System" | |
| x-displayName: "System" | |
| definitions: | |
| Port: | |
| type: "object" | |
| description: "An open port on a container" | |
| required: [PrivatePort, Type] | |
| properties: | |
| IP: | |
| type: "string" | |
| format: "ip-address" | |
| description: "Host IP address that the container's port is mapped to" | |
| PrivatePort: | |
| type: "integer" | |
| format: "uint16" | |
| x-nullable: false | |
| description: "Port on the container" | |
| PublicPort: | |
| type: "integer" | |
| format: "uint16" | |
| description: "Port exposed on the host" | |
| Type: | |
| type: "string" | |
| x-nullable: false | |
| enum: ["tcp", "udp", "sctp"] | |
| example: | |
| PrivatePort: 8080 | |
| PublicPort: 80 | |
| Type: "tcp" | |
| MountPoint: | |
| type: "object" | |
| description: | | |
| MountPoint represents a mount point configuration inside the container. | |
| This is used for reporting the mountpoints in use by a container. | |
| properties: | |
| Type: | |
| description: | | |
| The mount type: | |
| - `bind` a mount of a file or directory from the host into the container. | |
| - `volume` a docker volume with the given `Name`. | |
| - `tmpfs` a `tmpfs`. | |
| - `npipe` a named pipe from the host into the container. | |
| - `cluster` a Swarm cluster volume | |
| type: "string" | |
| enum: | |
| - "bind" | |
| - "volume" | |
| - "tmpfs" | |
| - "npipe" | |
| - "cluster" | |
| example: "volume" | |
| Name: | |
| description: | | |
| Name is the name reference to the underlying data defined by `Source` | |
| e.g., the volume name. | |
| type: "string" | |
| example: "myvolume" | |
| Source: | |
| description: | | |
| Source location of the mount. | |
| For volumes, this contains the storage location of the volume (within | |
| `/var/lib/docker/volumes/`). For bind-mounts, and `npipe`, this contains | |
| the source (host) part of the bind-mount. For `tmpfs` mount points, this | |
| field is empty. | |
| type: "string" | |
| example: "/var/lib/docker/volumes/myvolume/_data" | |
| Destination: | |
| description: | | |
| Destination is the path relative to the container root (`/`) where | |
| the `Source` is mounted inside the container. | |
| type: "string" | |
| example: "/usr/share/nginx/html/" | |
| Driver: | |
| description: | | |
| Driver is the volume driver used to create the volume (if it is a volume). | |
| type: "string" | |
| example: "local" | |
| Mode: | |
| description: | | |
| Mode is a comma separated list of options supplied by the user when | |
| creating the bind/volume mount. | |
| The default is platform-specific (`"z"` on Linux, empty on Windows). | |
| type: "string" | |
| example: "z" | |
| RW: | |
| description: | | |
| Whether the mount is mounted writable (read-write). | |
| type: "boolean" | |
| example: true | |
| Propagation: | |
| description: | | |
| Propagation describes how mounts are propagated from the host into the | |
| mount point, and vice-versa. Refer to the [Linux kernel documentation](https://www.kernel.org/doc/Documentation/filesystems/sharedsubtree.txt) | |
| for details. This field is not used on Windows. | |
| type: "string" | |
| example: "" | |
| DeviceMapping: | |
| type: "object" | |
| description: "A device mapping between the host and container" | |
| properties: | |
| PathOnHost: | |
| type: "string" | |
| PathInContainer: | |
| type: "string" | |
| CgroupPermissions: | |
| type: "string" | |
| example: | |
| PathOnHost: "/dev/deviceName" | |
| PathInContainer: "/dev/deviceName" | |
| CgroupPermissions: "mrw" | |
| DeviceRequest: | |
| type: "object" | |
| description: "A request for devices to be sent to device drivers" | |
| properties: | |
| Driver: | |
| type: "string" | |
| example: "nvidia" | |
| Count: | |
| type: "integer" | |
| example: -1 | |
| DeviceIDs: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "0" | |
| - "1" | |
| - "GPU-fef8089b-4820-abfc-e83e-94318197576e" | |
| Capabilities: | |
| description: | | |
| A list of capabilities; an OR list of AND lists of capabilities. | |
| type: "array" | |
| items: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| # gpu AND nvidia AND compute | |
| - ["gpu", "nvidia", "compute"] | |
| Options: | |
| description: | | |
| Driver-specific options, specified as a key/value pairs. These options | |
| are passed directly to the driver. | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| ThrottleDevice: | |
| type: "object" | |
| properties: | |
| Path: | |
| description: "Device path" | |
| type: "string" | |
| Rate: | |
| description: "Rate" | |
| type: "integer" | |
| format: "int64" | |
| minimum: 0 | |
| Mount: | |
| type: "object" | |
| properties: | |
| Target: | |
| description: "Container path." | |
| type: "string" | |
| Source: | |
| description: "Mount source (e.g. a volume name, a host path)." | |
| type: "string" | |
| Type: | |
| description: | | |
| The mount type. Available types: | |
| - `bind` Mounts a file or directory from the host into the container. Must exist prior to creating the container. | |
| - `volume` Creates a volume with the given name and options (or uses a pre-existing volume with the same name and options). These are **not** removed when the container is removed. | |
| - `tmpfs` Create a tmpfs with the given options. The mount source cannot be specified for tmpfs. | |
| - `npipe` Mounts a named pipe from the host into the container. Must exist prior to creating the container. | |
| - `cluster` a Swarm cluster volume | |
| type: "string" | |
| enum: | |
| - "bind" | |
| - "volume" | |
| - "tmpfs" | |
| - "npipe" | |
| - "cluster" | |
| ReadOnly: | |
| description: "Whether the mount should be read-only." | |
| type: "boolean" | |
| Consistency: | |
| description: "The consistency requirement for the mount: `default`, `consistent`, `cached`, or `delegated`." | |
| type: "string" | |
| BindOptions: | |
| description: "Optional configuration for the `bind` type." | |
| type: "object" | |
| properties: | |
| Propagation: | |
| description: "A propagation mode with the value `[r]private`, `[r]shared`, or `[r]slave`." | |
| type: "string" | |
| enum: | |
| - "private" | |
| - "rprivate" | |
| - "shared" | |
| - "rshared" | |
| - "slave" | |
| - "rslave" | |
| NonRecursive: | |
| description: "Disable recursive bind mount." | |
| type: "boolean" | |
| default: false | |
| CreateMountpoint: | |
| description: "Create mount point on host if missing" | |
| type: "boolean" | |
| default: false | |
| VolumeOptions: | |
| description: "Optional configuration for the `volume` type." | |
| type: "object" | |
| properties: | |
| NoCopy: | |
| description: "Populate volume with data from the target." | |
| type: "boolean" | |
| default: false | |
| Labels: | |
| description: "User-defined key/value metadata." | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| DriverConfig: | |
| description: "Map of driver specific options" | |
| type: "object" | |
| properties: | |
| Name: | |
| description: "Name of the driver to use to create the volume." | |
| type: "string" | |
| Options: | |
| description: "key/value map of driver specific options." | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| TmpfsOptions: | |
| description: "Optional configuration for the `tmpfs` type." | |
| type: "object" | |
| properties: | |
| SizeBytes: | |
| description: "The size for the tmpfs mount in bytes." | |
| type: "integer" | |
| format: "int64" | |
| Mode: | |
| description: "The permission mode for the tmpfs mount in an integer." | |
| type: "integer" | |
| RestartPolicy: | |
| description: | | |
| The behavior to apply when the container exits. The default is not to | |
| restart. | |
| An ever increasing delay (double the previous delay, starting at 100ms) is | |
| added before each restart to prevent flooding the server. | |
| type: "object" | |
| properties: | |
| Name: | |
| type: "string" | |
| description: | | |
| - Empty string means not to restart | |
| - `no` Do not automatically restart | |
| - `always` Always restart | |
| - `unless-stopped` Restart always except when the user has manually stopped the container | |
| - `on-failure` Restart only when the container exit code is non-zero | |
| enum: | |
| - "" | |
| - "no" | |
| - "always" | |
| - "unless-stopped" | |
| - "on-failure" | |
| MaximumRetryCount: | |
| type: "integer" | |
| description: | | |
| If `on-failure` is used, the number of times to retry before giving up. | |
| Resources: | |
| description: "A container's resources (cgroups config, ulimits, etc)" | |
| type: "object" | |
| properties: | |
| # Applicable to all platforms | |
| CpuShares: | |
| description: | | |
| An integer value representing this container's relative CPU weight | |
| versus other containers. | |
| type: "integer" | |
| Memory: | |
| description: "Memory limit in bytes." | |
| type: "integer" | |
| format: "int64" | |
| default: 0 | |
| # Applicable to UNIX platforms | |
| CgroupParent: | |
| description: | | |
| Path to `cgroups` under which the container's `cgroup` is created. If | |
| the path is not absolute, the path is considered to be relative to the | |
| `cgroups` path of the init process. Cgroups are created if they do not | |
| already exist. | |
| type: "string" | |
| BlkioWeight: | |
| description: "Block IO weight (relative weight)." | |
| type: "integer" | |
| minimum: 0 | |
| maximum: 1000 | |
| BlkioWeightDevice: | |
| description: | | |
| Block IO weight (relative device weight) in the form: | |
| ``` | |
| [{"Path": "device_path", "Weight": weight}] | |
| ``` | |
| type: "array" | |
| items: | |
| type: "object" | |
| properties: | |
| Path: | |
| type: "string" | |
| Weight: | |
| type: "integer" | |
| minimum: 0 | |
| BlkioDeviceReadBps: | |
| description: | | |
| Limit read rate (bytes per second) from a device, in the form: | |
| ``` | |
| [{"Path": "device_path", "Rate": rate}] | |
| ``` | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/ThrottleDevice" | |
| BlkioDeviceWriteBps: | |
| description: | | |
| Limit write rate (bytes per second) to a device, in the form: | |
| ``` | |
| [{"Path": "device_path", "Rate": rate}] | |
| ``` | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/ThrottleDevice" | |
| BlkioDeviceReadIOps: | |
| description: | | |
| Limit read rate (IO per second) from a device, in the form: | |
| ``` | |
| [{"Path": "device_path", "Rate": rate}] | |
| ``` | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/ThrottleDevice" | |
| BlkioDeviceWriteIOps: | |
| description: | | |
| Limit write rate (IO per second) to a device, in the form: | |
| ``` | |
| [{"Path": "device_path", "Rate": rate}] | |
| ``` | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/ThrottleDevice" | |
| CpuPeriod: | |
| description: "The length of a CPU period in microseconds." | |
| type: "integer" | |
| format: "int64" | |
| CpuQuota: | |
| description: | | |
| Microseconds of CPU time that the container can get in a CPU period. | |
| type: "integer" | |
| format: "int64" | |
| CpuRealtimePeriod: | |
| description: | | |
| The length of a CPU real-time period in microseconds. Set to 0 to | |
| allocate no time allocated to real-time tasks. | |
| type: "integer" | |
| format: "int64" | |
| CpuRealtimeRuntime: | |
| description: | | |
| The length of a CPU real-time runtime in microseconds. Set to 0 to | |
| allocate no time allocated to real-time tasks. | |
| type: "integer" | |
| format: "int64" | |
| CpusetCpus: | |
| description: | | |
| CPUs in which to allow execution (e.g., `0-3`, `0,1`). | |
| type: "string" | |
| example: "0-3" | |
| CpusetMems: | |
| description: | | |
| Memory nodes (MEMs) in which to allow execution (0-3, 0,1). Only | |
| effective on NUMA systems. | |
| type: "string" | |
| Devices: | |
| description: "A list of devices to add to the container." | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/DeviceMapping" | |
| DeviceCgroupRules: | |
| description: "a list of cgroup rules to apply to the container" | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: "c 13:* rwm" | |
| DeviceRequests: | |
| description: | | |
| A list of requests for devices to be sent to device drivers. | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/DeviceRequest" | |
| KernelMemoryTCP: | |
| description: | | |
| Hard limit for kernel TCP buffer memory (in bytes). Depending on the | |
| OCI runtime in use, this option may be ignored. It is no longer supported | |
| by the default (runc) runtime. | |
| This field is omitted when empty. | |
| type: "integer" | |
| format: "int64" | |
| MemoryReservation: | |
| description: "Memory soft limit in bytes." | |
| type: "integer" | |
| format: "int64" | |
| MemorySwap: | |
| description: | | |
| Total memory limit (memory + swap). Set as `-1` to enable unlimited | |
| swap. | |
| type: "integer" | |
| format: "int64" | |
| MemorySwappiness: | |
| description: | | |
| Tune a container's memory swappiness behavior. Accepts an integer | |
| between 0 and 100. | |
| type: "integer" | |
| format: "int64" | |
| minimum: 0 | |
| maximum: 100 | |
| NanoCpus: | |
| description: "CPU quota in units of 10<sup>-9</sup> CPUs." | |
| type: "integer" | |
| format: "int64" | |
| OomKillDisable: | |
| description: "Disable OOM Killer for the container." | |
| type: "boolean" | |
| Init: | |
| description: | | |
| Run an init inside the container that forwards signals and reaps | |
| processes. This field is omitted if empty, and the default (as | |
| configured on the daemon) is used. | |
| type: "boolean" | |
| x-nullable: true | |
| PidsLimit: | |
| description: | | |
| Tune a container's PIDs limit. Set `0` or `-1` for unlimited, or `null` | |
| to not change. | |
| type: "integer" | |
| format: "int64" | |
| x-nullable: true | |
| Ulimits: | |
| description: | | |
| A list of resource limits to set in the container. For example: | |
| ``` | |
| {"Name": "nofile", "Soft": 1024, "Hard": 2048} | |
| ``` | |
| type: "array" | |
| items: | |
| type: "object" | |
| properties: | |
| Name: | |
| description: "Name of ulimit" | |
| type: "string" | |
| Soft: | |
| description: "Soft limit" | |
| type: "integer" | |
| Hard: | |
| description: "Hard limit" | |
| type: "integer" | |
| # Applicable to Windows | |
| CpuCount: | |
| description: | | |
| The number of usable CPUs (Windows only). | |
| On Windows Server containers, the processor resource controls are | |
| mutually exclusive. The order of precedence is `CPUCount` first, then | |
| `CPUShares`, and `CPUPercent` last. | |
| type: "integer" | |
| format: "int64" | |
| CpuPercent: | |
| description: | | |
| The usable percentage of the available CPUs (Windows only). | |
| On Windows Server containers, the processor resource controls are | |
| mutually exclusive. The order of precedence is `CPUCount` first, then | |
| `CPUShares`, and `CPUPercent` last. | |
| type: "integer" | |
| format: "int64" | |
| IOMaximumIOps: | |
| description: "Maximum IOps for the container system drive (Windows only)" | |
| type: "integer" | |
| format: "int64" | |
| IOMaximumBandwidth: | |
| description: | | |
| Maximum IO in bytes per second for the container system drive | |
| (Windows only). | |
| type: "integer" | |
| format: "int64" | |
| Limit: | |
| description: | | |
| An object describing a limit on resources which can be requested by a task. | |
| type: "object" | |
| properties: | |
| NanoCPUs: | |
| type: "integer" | |
| format: "int64" | |
| example: 4000000000 | |
| MemoryBytes: | |
| type: "integer" | |
| format: "int64" | |
| example: 8272408576 | |
| Pids: | |
| description: | | |
| Limits the maximum number of PIDs in the container. Set `0` for unlimited. | |
| type: "integer" | |
| format: "int64" | |
| default: 0 | |
| example: 100 | |
| ResourceObject: | |
| description: | | |
| An object describing the resources which can be advertised by a node and | |
| requested by a task. | |
| type: "object" | |
| properties: | |
| NanoCPUs: | |
| type: "integer" | |
| format: "int64" | |
| example: 4000000000 | |
| MemoryBytes: | |
| type: "integer" | |
| format: "int64" | |
| example: 8272408576 | |
| GenericResources: | |
| $ref: "#/definitions/GenericResources" | |
| GenericResources: | |
| description: | | |
| User-defined resources can be either Integer resources (e.g, `SSD=3`) or | |
| String resources (e.g, `GPU=UUID1`). | |
| type: "array" | |
| items: | |
| type: "object" | |
| properties: | |
| NamedResourceSpec: | |
| type: "object" | |
| properties: | |
| Kind: | |
| type: "string" | |
| Value: | |
| type: "string" | |
| DiscreteResourceSpec: | |
| type: "object" | |
| properties: | |
| Kind: | |
| type: "string" | |
| Value: | |
| type: "integer" | |
| format: "int64" | |
| example: | |
| - DiscreteResourceSpec: | |
| Kind: "SSD" | |
| Value: 3 | |
| - NamedResourceSpec: | |
| Kind: "GPU" | |
| Value: "UUID1" | |
| - NamedResourceSpec: | |
| Kind: "GPU" | |
| Value: "UUID2" | |
| HealthConfig: | |
| description: "A test to perform to check that the container is healthy." | |
| type: "object" | |
| properties: | |
| Test: | |
| description: | | |
| The test to perform. Possible values are: | |
| - `[]` inherit healthcheck from image or parent image | |
| - `["NONE"]` disable healthcheck | |
| - `["CMD", args...]` exec arguments directly | |
| - `["CMD-SHELL", command]` run command with system's default shell | |
| type: "array" | |
| items: | |
| type: "string" | |
| Interval: | |
| description: | | |
| The time to wait between checks in nanoseconds. It should be 0 or at | |
| least 1000000 (1 ms). 0 means inherit. | |
| type: "integer" | |
| format: "int64" | |
| Timeout: | |
| description: | | |
| The time to wait before considering the check to have hung. It should | |
| be 0 or at least 1000000 (1 ms). 0 means inherit. | |
| type: "integer" | |
| format: "int64" | |
| Retries: | |
| description: | | |
| The number of consecutive failures needed to consider a container as | |
| unhealthy. 0 means inherit. | |
| type: "integer" | |
| StartPeriod: | |
| description: | | |
| Start period for the container to initialize before starting | |
| health-retries countdown in nanoseconds. It should be 0 or at least | |
| 1000000 (1 ms). 0 means inherit. | |
| type: "integer" | |
| format: "int64" | |
| Health: | |
| description: | | |
| Health stores information about the container's healthcheck results. | |
| type: "object" | |
| x-nullable: true | |
| properties: | |
| Status: | |
| description: | | |
| Status is one of `none`, `starting`, `healthy` or `unhealthy` | |
| - "none" Indicates there is no healthcheck | |
| - "starting" Starting indicates that the container is not yet ready | |
| - "healthy" Healthy indicates that the container is running correctly | |
| - "unhealthy" Unhealthy indicates that the container has a problem | |
| type: "string" | |
| enum: | |
| - "none" | |
| - "starting" | |
| - "healthy" | |
| - "unhealthy" | |
| example: "healthy" | |
| FailingStreak: | |
| description: "FailingStreak is the number of consecutive failures" | |
| type: "integer" | |
| example: 0 | |
| Log: | |
| type: "array" | |
| description: | | |
| Log contains the last few results (oldest first) | |
| items: | |
| $ref: "#/definitions/HealthcheckResult" | |
| HealthcheckResult: | |
| description: | | |
| HealthcheckResult stores information about a single run of a healthcheck probe | |
| type: "object" | |
| x-nullable: true | |
| properties: | |
| Start: | |
| description: | | |
| Date and time at which this check started in | |
| [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format with nano-seconds. | |
| type: "string" | |
| format: "date-time" | |
| example: "2020-01-04T10:44:24.496525531Z" | |
| End: | |
| description: | | |
| Date and time at which this check ended in | |
| [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format with nano-seconds. | |
| type: "string" | |
| format: "dateTime" | |
| example: "2020-01-04T10:45:21.364524523Z" | |
| ExitCode: | |
| description: | | |
| ExitCode meanings: | |
| - `0` healthy | |
| - `1` unhealthy | |
| - `2` reserved (considered unhealthy) | |
| - other values: error running probe | |
| type: "integer" | |
| example: 0 | |
| Output: | |
| description: "Output from last check" | |
| type: "string" | |
| HostConfig: | |
| description: "Container configuration that depends on the host we are running on" | |
| allOf: | |
| - $ref: "#/definitions/Resources" | |
| - type: "object" | |
| properties: | |
| # Applicable to all platforms | |
| Binds: | |
| type: "array" | |
| description: | | |
| A list of volume bindings for this container. Each volume binding | |
| is a string in one of these forms: | |
| - `host-src:container-dest[:options]` to bind-mount a host path | |
| into the container. Both `host-src`, and `container-dest` must | |
| be an _absolute_ path. | |
| - `volume-name:container-dest[:options]` to bind-mount a volume | |
| managed by a volume driver into the container. `container-dest` | |
| must be an _absolute_ path. | |
| `options` is an optional, comma-delimited list of: | |
| - `nocopy` disables automatic copying of data from the container | |
| path to the volume. The `nocopy` flag only applies to named volumes. | |
| - `[ro|rw]` mounts a volume read-only or read-write, respectively. | |
| If omitted or set to `rw`, volumes are mounted read-write. | |
| - `[z|Z]` applies SELinux labels to allow or deny multiple containers | |
| to read and write to the same volume. | |
| - `z`: a _shared_ content label is applied to the content. This | |
| label indicates that multiple containers can share the volume | |
| content, for both reading and writing. | |
| - `Z`: a _private unshared_ label is applied to the content. | |
| This label indicates that only the current container can use | |
| a private volume. Labeling systems such as SELinux require | |
| proper labels to be placed on volume content that is mounted | |
| into a container. Without a label, the security system can | |
| prevent a container's processes from using the content. By | |
| default, the labels set by the host operating system are not | |
| modified. | |
| - `[[r]shared|[r]slave|[r]private]` specifies mount | |
| [propagation behavior](https://www.kernel.org/doc/Documentation/filesystems/sharedsubtree.txt). | |
| This only applies to bind-mounted volumes, not internal volumes | |
| or named volumes. Mount propagation requires the source mount | |
| point (the location where the source directory is mounted in the | |
| host operating system) to have the correct propagation properties. | |
| For shared volumes, the source mount point must be set to `shared`. | |
| For slave volumes, the mount must be set to either `shared` or | |
| `slave`. | |
| items: | |
| type: "string" | |
| ContainerIDFile: | |
| type: "string" | |
| description: "Path to a file where the container ID is written" | |
| LogConfig: | |
| type: "object" | |
| description: "The logging configuration for this container" | |
| properties: | |
| Type: | |
| type: "string" | |
| enum: | |
| - "json-file" | |
| - "syslog" | |
| - "journald" | |
| - "gelf" | |
| - "fluentd" | |
| - "awslogs" | |
| - "splunk" | |
| - "etwlogs" | |
| - "none" | |
| Config: | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| NetworkMode: | |
| type: "string" | |
| description: | | |
| Network mode to use for this container. Supported standard values | |
| are: `bridge`, `host`, `none`, and `container:<name|id>`. Any | |
| other value is taken as a custom network's name to which this | |
| container should connect to. | |
| PortBindings: | |
| $ref: "#/definitions/PortMap" | |
| RestartPolicy: | |
| $ref: "#/definitions/RestartPolicy" | |
| AutoRemove: | |
| type: "boolean" | |
| description: | | |
| Automatically remove the container when the container's process | |
| exits. This has no effect if `RestartPolicy` is set. | |
| VolumeDriver: | |
| type: "string" | |
| description: "Driver that this container uses to mount volumes." | |
| VolumesFrom: | |
| type: "array" | |
| description: | | |
| A list of volumes to inherit from another container, specified in | |
| the form `<container name>[:<ro|rw>]`. | |
| items: | |
| type: "string" | |
| Mounts: | |
| description: | | |
| Specification for mounts to be added to the container. | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/Mount" | |
| ConsoleSize: | |
| type: "array" | |
| description: | | |
| Initial console size, as an `[height, width]` array. | |
| x-nullable: true | |
| minItems: 2 | |
| maxItems: 2 | |
| items: | |
| type: "integer" | |
| minimum: 0 | |
| Annotations: | |
| type: "object" | |
| description: | | |
| Arbitrary non-identifying metadata attached to container and | |
| provided to the runtime when the container is started. | |
| additionalProperties: | |
| type: "string" | |
| # Applicable to UNIX platforms | |
| CapAdd: | |
| type: "array" | |
| description: | | |
| A list of kernel capabilities to add to the container. Conflicts | |
| with option 'Capabilities'. | |
| items: | |
| type: "string" | |
| CapDrop: | |
| type: "array" | |
| description: | | |
| A list of kernel capabilities to drop from the container. Conflicts | |
| with option 'Capabilities'. | |
| items: | |
| type: "string" | |
| CgroupnsMode: | |
| type: "string" | |
| enum: | |
| - "private" | |
| - "host" | |
| description: | | |
| cgroup namespace mode for the container. Possible values are: | |
| - `"private"`: the container runs in its own private cgroup namespace | |
| - `"host"`: use the host system's cgroup namespace | |
| If not specified, the daemon default is used, which can either be `"private"` | |
| or `"host"`, depending on daemon version, kernel support and configuration. | |
| Dns: | |
| type: "array" | |
| description: "A list of DNS servers for the container to use." | |
| items: | |
| type: "string" | |
| DnsOptions: | |
| type: "array" | |
| description: "A list of DNS options." | |
| items: | |
| type: "string" | |
| DnsSearch: | |
| type: "array" | |
| description: "A list of DNS search domains." | |
| items: | |
| type: "string" | |
| ExtraHosts: | |
| type: "array" | |
| description: | | |
| A list of hostnames/IP mappings to add to the container's `/etc/hosts` | |
| file. Specified in the form `["hostname:IP"]`. | |
| items: | |
| type: "string" | |
| GroupAdd: | |
| type: "array" | |
| description: | | |
| A list of additional groups that the container process will run as. | |
| items: | |
| type: "string" | |
| IpcMode: | |
| type: "string" | |
| description: | | |
| IPC sharing mode for the container. Possible values are: | |
| - `"none"`: own private IPC namespace, with /dev/shm not mounted | |
| - `"private"`: own private IPC namespace | |
| - `"shareable"`: own private IPC namespace, with a possibility to share it with other containers | |
| - `"container:<name|id>"`: join another (shareable) container's IPC namespace | |
| - `"host"`: use the host system's IPC namespace | |
| If not specified, daemon default is used, which can either be `"private"` | |
| or `"shareable"`, depending on daemon version and configuration. | |
| Cgroup: | |
| type: "string" | |
| description: "Cgroup to use for the container." | |
| Links: | |
| type: "array" | |
| description: | | |
| A list of links for the container in the form `container_name:alias`. | |
| items: | |
| type: "string" | |
| OomScoreAdj: | |
| type: "integer" | |
| description: | | |
| An integer value containing the score given to the container in | |
| order to tune OOM killer preferences. | |
| example: 500 | |
| PidMode: | |
| type: "string" | |
| description: | | |
| Set the PID (Process) Namespace mode for the container. It can be | |
| either: | |
| - `"container:<name|id>"`: joins another container's PID namespace | |
| - `"host"`: use the host's PID namespace inside the container | |
| Privileged: | |
| type: "boolean" | |
| description: "Gives the container full access to the host." | |
| PublishAllPorts: | |
| type: "boolean" | |
| description: | | |
| Allocates an ephemeral host port for all of a container's | |
| exposed ports. | |
| Ports are de-allocated when the container stops and allocated when | |
| the container starts. The allocated port might be changed when | |
| restarting the container. | |
| The port is selected from the ephemeral port range that depends on | |
| the kernel. For example, on Linux the range is defined by | |
| `/proc/sys/net/ipv4/ip_local_port_range`. | |
| ReadonlyRootfs: | |
| type: "boolean" | |
| description: "Mount the container's root filesystem as read only." | |
| SecurityOpt: | |
| type: "array" | |
| description: | | |
| A list of string values to customize labels for MLS systems, such | |
| as SELinux. | |
| items: | |
| type: "string" | |
| StorageOpt: | |
| type: "object" | |
| description: | | |
| Storage driver options for this container, in the form `{"size": "120G"}`. | |
| additionalProperties: | |
| type: "string" | |
| Tmpfs: | |
| type: "object" | |
| description: | | |
| A map of container directories which should be replaced by tmpfs | |
| mounts, and their corresponding mount options. For example: | |
| ``` | |
| { "/run": "rw,noexec,nosuid,size=65536k" } | |
| ``` | |
| additionalProperties: | |
| type: "string" | |
| UTSMode: | |
| type: "string" | |
| description: "UTS namespace to use for the container." | |
| UsernsMode: | |
| type: "string" | |
| description: | | |
| Sets the usernamespace mode for the container when usernamespace | |
| remapping option is enabled. | |
| ShmSize: | |
| type: "integer" | |
| format: "int64" | |
| description: | | |
| Size of `/dev/shm` in bytes. If omitted, the system uses 64MB. | |
| minimum: 0 | |
| Sysctls: | |
| type: "object" | |
| description: | | |
| A list of kernel parameters (sysctls) to set in the container. | |
| For example: | |
| ``` | |
| {"net.ipv4.ip_forward": "1"} | |
| ``` | |
| additionalProperties: | |
| type: "string" | |
| Runtime: | |
| type: "string" | |
| description: "Runtime to use with this container." | |
| # Applicable to Windows | |
| Isolation: | |
| type: "string" | |
| description: | | |
| Isolation technology of the container. (Windows only) | |
| enum: | |
| - "default" | |
| - "process" | |
| - "hyperv" | |
| MaskedPaths: | |
| type: "array" | |
| description: | | |
| The list of paths to be masked inside the container (this overrides | |
| the default set of paths). | |
| items: | |
| type: "string" | |
| ReadonlyPaths: | |
| type: "array" | |
| description: | | |
| The list of paths to be set as read-only inside the container | |
| (this overrides the default set of paths). | |
| items: | |
| type: "string" | |
| ContainerConfig: | |
| description: | | |
| Configuration for a container that is portable between hosts. | |
| When used as `ContainerConfig` field in an image, `ContainerConfig` is an | |
| optional field containing the configuration of the container that was last | |
| committed when creating the image. | |
| Previous versions of Docker builder used this field to store build cache, | |
| and it is not in active use anymore. | |
| type: "object" | |
| properties: | |
| Hostname: | |
| description: | | |
| The hostname to use for the container, as a valid RFC 1123 hostname. | |
| type: "string" | |
| example: "439f4e91bd1d" | |
| Domainname: | |
| description: | | |
| The domain name to use for the container. | |
| type: "string" | |
| User: | |
| description: "The user that commands are run as inside the container." | |
| type: "string" | |
| AttachStdin: | |
| description: "Whether to attach to `stdin`." | |
| type: "boolean" | |
| default: false | |
| AttachStdout: | |
| description: "Whether to attach to `stdout`." | |
| type: "boolean" | |
| default: true | |
| AttachStderr: | |
| description: "Whether to attach to `stderr`." | |
| type: "boolean" | |
| default: true | |
| ExposedPorts: | |
| description: | | |
| An object mapping ports to an empty object in the form: | |
| `{"<port>/<tcp|udp|sctp>": {}}` | |
| type: "object" | |
| x-nullable: true | |
| additionalProperties: | |
| type: "object" | |
| enum: | |
| - {} | |
| default: {} | |
| example: { | |
| "80/tcp": {}, | |
| "443/tcp": {} | |
| } | |
| Tty: | |
| description: | | |
| Attach standard streams to a TTY, including `stdin` if it is not closed. | |
| type: "boolean" | |
| default: false | |
| OpenStdin: | |
| description: "Open `stdin`" | |
| type: "boolean" | |
| default: false | |
| StdinOnce: | |
| description: "Close `stdin` after one attached client disconnects" | |
| type: "boolean" | |
| default: false | |
| Env: | |
| description: | | |
| A list of environment variables to set inside the container in the | |
| form `["VAR=value", ...]`. A variable without `=` is removed from the | |
| environment, rather than to have an empty value. | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin" | |
| Cmd: | |
| description: | | |
| Command to run specified as a string or an array of strings. | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: ["/bin/sh"] | |
| Healthcheck: | |
| $ref: "#/definitions/HealthConfig" | |
| ArgsEscaped: | |
| description: "Command is already escaped (Windows only)" | |
| type: "boolean" | |
| default: false | |
| example: false | |
| x-nullable: true | |
| Image: | |
| description: | | |
| The name (or reference) of the image to use when creating the container, | |
| or which was used when the container was created. | |
| type: "string" | |
| example: "example-image:1.0" | |
| Volumes: | |
| description: | | |
| An object mapping mount point paths inside the container to empty | |
| objects. | |
| type: "object" | |
| additionalProperties: | |
| type: "object" | |
| enum: | |
| - {} | |
| default: {} | |
| WorkingDir: | |
| description: "The working directory for commands to run in." | |
| type: "string" | |
| example: "/public/" | |
| Entrypoint: | |
| description: | | |
| The entry point for the container as a string or an array of strings. | |
| If the array consists of exactly one empty string (`[""]`) then the | |
| entry point is reset to system default (i.e., the entry point used by | |
| docker when there is no `ENTRYPOINT` instruction in the `Dockerfile`). | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: [] | |
| NetworkDisabled: | |
| description: "Disable networking for the container." | |
| type: "boolean" | |
| x-nullable: true | |
| MacAddress: | |
| description: "MAC address of the container." | |
| type: "string" | |
| x-nullable: true | |
| OnBuild: | |
| description: | | |
| `ONBUILD` metadata that were defined in the image's `Dockerfile`. | |
| type: "array" | |
| x-nullable: true | |
| items: | |
| type: "string" | |
| example: [] | |
| Labels: | |
| description: "User-defined key/value metadata." | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| com.example.some-label: "some-value" | |
| com.example.some-other-label: "some-other-value" | |
| StopSignal: | |
| description: | | |
| Signal to stop a container as a string or unsigned integer. | |
| type: "string" | |
| example: "SIGTERM" | |
| x-nullable: true | |
| StopTimeout: | |
| description: "Timeout to stop a container in seconds." | |
| type: "integer" | |
| default: 10 | |
| x-nullable: true | |
| Shell: | |
| description: | | |
| Shell for when `RUN`, `CMD`, and `ENTRYPOINT` uses a shell. | |
| type: "array" | |
| x-nullable: true | |
| items: | |
| type: "string" | |
| example: ["/bin/sh", "-c"] | |
| NetworkingConfig: | |
| description: | | |
| NetworkingConfig represents the container's networking configuration for | |
| each of its interfaces. | |
| It is used for the networking configs specified in the `docker create` | |
| and `docker network connect` commands. | |
| type: "object" | |
| properties: | |
| EndpointsConfig: | |
| description: | | |
| A mapping of network name to endpoint configuration for that network. | |
| type: "object" | |
| additionalProperties: | |
| $ref: "#/definitions/EndpointSettings" | |
| example: | |
| # putting an example here, instead of using the example values from | |
| # /definitions/EndpointSettings, because containers/create currently | |
| # does not support attaching to multiple networks, so the example request | |
| # would be confusing if it showed that multiple networks can be contained | |
| # in the EndpointsConfig. | |
| # TODO remove once we support multiple networks on container create (see https://github.com/moby/moby/blob/07e6b843594e061f82baa5fa23c2ff7d536c2a05/daemon/create.go#L323) | |
| EndpointsConfig: | |
| isolated_nw: | |
| IPAMConfig: | |
| IPv4Address: "172.20.30.33" | |
| IPv6Address: "2001:db8:abcd::3033" | |
| LinkLocalIPs: | |
| - "169.254.34.68" | |
| - "fe80::3468" | |
| Links: | |
| - "container_1" | |
| - "container_2" | |
| Aliases: | |
| - "server_x" | |
| - "server_y" | |
| NetworkSettings: | |
| description: "NetworkSettings exposes the network settings in the API" | |
| type: "object" | |
| properties: | |
| Bridge: | |
| description: Name of the network's bridge (for example, `docker0`). | |
| type: "string" | |
| example: "docker0" | |
| SandboxID: | |
| description: SandboxID uniquely represents a container's network stack. | |
| type: "string" | |
| example: "9d12daf2c33f5959c8bf90aa513e4f65b561738661003029ec84830cd503a0c3" | |
| HairpinMode: | |
| description: | | |
| Indicates if hairpin NAT should be enabled on the virtual interface. | |
| type: "boolean" | |
| example: false | |
| LinkLocalIPv6Address: | |
| description: IPv6 unicast address using the link-local prefix. | |
| type: "string" | |
| example: "fe80::42:acff:fe11:1" | |
| LinkLocalIPv6PrefixLen: | |
| description: Prefix length of the IPv6 unicast address. | |
| type: "integer" | |
| example: "64" | |
| Ports: | |
| $ref: "#/definitions/PortMap" | |
| SandboxKey: | |
| description: SandboxKey identifies the sandbox | |
| type: "string" | |
| example: "/var/run/docker/netns/8ab54b426c38" | |
| # TODO is SecondaryIPAddresses actually used? | |
| SecondaryIPAddresses: | |
| description: "" | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/Address" | |
| x-nullable: true | |
| # TODO is SecondaryIPv6Addresses actually used? | |
| SecondaryIPv6Addresses: | |
| description: "" | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/Address" | |
| x-nullable: true | |
| # TODO properties below are part of DefaultNetworkSettings, which is | |
| # marked as deprecated since Docker 1.9 and to be removed in Docker v17.12 | |
| EndpointID: | |
| description: | | |
| EndpointID uniquely represents a service endpoint in a Sandbox. | |
| <p><br /></p> | |
| > **Deprecated**: This field is only propagated when attached to the | |
| > default "bridge" network. Use the information from the "bridge" | |
| > network inside the `Networks` map instead, which contains the same | |
| > information. This field was deprecated in Docker 1.9 and is scheduled | |
| > to be removed in Docker 17.12.0 | |
| type: "string" | |
| example: "b88f5b905aabf2893f3cbc4ee42d1ea7980bbc0a92e2c8922b1e1795298afb0b" | |
| Gateway: | |
| description: | | |
| Gateway address for the default "bridge" network. | |
| <p><br /></p> | |
| > **Deprecated**: This field is only propagated when attached to the | |
| > default "bridge" network. Use the information from the "bridge" | |
| > network inside the `Networks` map instead, which contains the same | |
| > information. This field was deprecated in Docker 1.9 and is scheduled | |
| > to be removed in Docker 17.12.0 | |
| type: "string" | |
| example: "172.17.0.1" | |
| GlobalIPv6Address: | |
| description: | | |
| Global IPv6 address for the default "bridge" network. | |
| <p><br /></p> | |
| > **Deprecated**: This field is only propagated when attached to the | |
| > default "bridge" network. Use the information from the "bridge" | |
| > network inside the `Networks` map instead, which contains the same | |
| > information. This field was deprecated in Docker 1.9 and is scheduled | |
| > to be removed in Docker 17.12.0 | |
| type: "string" | |
| example: "2001:db8::5689" | |
| GlobalIPv6PrefixLen: | |
| description: | | |
| Mask length of the global IPv6 address. | |
| <p><br /></p> | |
| > **Deprecated**: This field is only propagated when attached to the | |
| > default "bridge" network. Use the information from the "bridge" | |
| > network inside the `Networks` map instead, which contains the same | |
| > information. This field was deprecated in Docker 1.9 and is scheduled | |
| > to be removed in Docker 17.12.0 | |
| type: "integer" | |
| example: 64 | |
| IPAddress: | |
| description: | | |
| IPv4 address for the default "bridge" network. | |
| <p><br /></p> | |
| > **Deprecated**: This field is only propagated when attached to the | |
| > default "bridge" network. Use the information from the "bridge" | |
| > network inside the `Networks` map instead, which contains the same | |
| > information. This field was deprecated in Docker 1.9 and is scheduled | |
| > to be removed in Docker 17.12.0 | |
| type: "string" | |
| example: "172.17.0.4" | |
| IPPrefixLen: | |
| description: | | |
| Mask length of the IPv4 address. | |
| <p><br /></p> | |
| > **Deprecated**: This field is only propagated when attached to the | |
| > default "bridge" network. Use the information from the "bridge" | |
| > network inside the `Networks` map instead, which contains the same | |
| > information. This field was deprecated in Docker 1.9 and is scheduled | |
| > to be removed in Docker 17.12.0 | |
| type: "integer" | |
| example: 16 | |
| IPv6Gateway: | |
| description: | | |
| IPv6 gateway address for this network. | |
| <p><br /></p> | |
| > **Deprecated**: This field is only propagated when attached to the | |
| > default "bridge" network. Use the information from the "bridge" | |
| > network inside the `Networks` map instead, which contains the same | |
| > information. This field was deprecated in Docker 1.9 and is scheduled | |
| > to be removed in Docker 17.12.0 | |
| type: "string" | |
| example: "2001:db8:2::100" | |
| MacAddress: | |
| description: | | |
| MAC address for the container on the default "bridge" network. | |
| <p><br /></p> | |
| > **Deprecated**: This field is only propagated when attached to the | |
| > default "bridge" network. Use the information from the "bridge" | |
| > network inside the `Networks` map instead, which contains the same | |
| > information. This field was deprecated in Docker 1.9 and is scheduled | |
| > to be removed in Docker 17.12.0 | |
| type: "string" | |
| example: "02:42:ac:11:00:04" | |
| Networks: | |
| description: | | |
| Information about all networks that the container is connected to. | |
| type: "object" | |
| additionalProperties: | |
| $ref: "#/definitions/EndpointSettings" | |
| Address: | |
| description: Address represents an IPv4 or IPv6 IP address. | |
| type: "object" | |
| properties: | |
| Addr: | |
| description: IP address. | |
| type: "string" | |
| PrefixLen: | |
| description: Mask length of the IP address. | |
| type: "integer" | |
| PortMap: | |
| description: | | |
| PortMap describes the mapping of container ports to host ports, using the | |
| container's port-number and protocol as key in the format `<port>/<protocol>`, | |
| for example, `80/udp`. | |
| If a container's port is mapped for multiple protocols, separate entries | |
| are added to the mapping table. | |
| type: "object" | |
| additionalProperties: | |
| type: "array" | |
| x-nullable: true | |
| items: | |
| $ref: "#/definitions/PortBinding" | |
| example: | |
| "443/tcp": | |
| - HostIp: "127.0.0.1" | |
| HostPort: "4443" | |
| "80/tcp": | |
| - HostIp: "0.0.0.0" | |
| HostPort: "80" | |
| - HostIp: "0.0.0.0" | |
| HostPort: "8080" | |
| "80/udp": | |
| - HostIp: "0.0.0.0" | |
| HostPort: "80" | |
| "53/udp": | |
| - HostIp: "0.0.0.0" | |
| HostPort: "53" | |
| "2377/tcp": null | |
| PortBinding: | |
| description: | | |
| PortBinding represents a binding between a host IP address and a host | |
| port. | |
| type: "object" | |
| properties: | |
| HostIp: | |
| description: "Host IP address that the container's port is mapped to." | |
| type: "string" | |
| example: "127.0.0.1" | |
| HostPort: | |
| description: "Host port number that the container's port is mapped to." | |
| type: "string" | |
| example: "4443" | |
| GraphDriverData: | |
| description: | | |
| Information about the storage driver used to store the container's and | |
| image's filesystem. | |
| type: "object" | |
| required: [Name, Data] | |
| properties: | |
| Name: | |
| description: "Name of the storage driver." | |
| type: "string" | |
| x-nullable: false | |
| example: "overlay2" | |
| Data: | |
| description: | | |
| Low-level storage metadata, provided as key/value pairs. | |
| This information is driver-specific, and depends on the storage-driver | |
| in use, and should be used for informational purposes only. | |
| type: "object" | |
| x-nullable: false | |
| additionalProperties: | |
| type: "string" | |
| example: { | |
| "MergedDir": "/var/lib/docker/overlay2/ef749362d13333e65fc95c572eb525abbe0052e16e086cb64bc3b98ae9aa6d74/merged", | |
| "UpperDir": "/var/lib/docker/overlay2/ef749362d13333e65fc95c572eb525abbe0052e16e086cb64bc3b98ae9aa6d74/diff", | |
| "WorkDir": "/var/lib/docker/overlay2/ef749362d13333e65fc95c572eb525abbe0052e16e086cb64bc3b98ae9aa6d74/work" | |
| } | |
| FilesystemChange: | |
| description: | | |
| Change in the container's filesystem. | |
| type: "object" | |
| required: [Path, Kind] | |
| properties: | |
| Path: | |
| description: | | |
| Path to file or directory that has changed. | |
| type: "string" | |
| x-nullable: false | |
| Kind: | |
| $ref: "#/definitions/ChangeType" | |
| ChangeType: | |
| description: | | |
| Kind of change | |
| Can be one of: | |
| - `0`: Modified ("C") | |
| - `1`: Added ("A") | |
| - `2`: Deleted ("D") | |
| type: "integer" | |
| format: "uint8" | |
| enum: [0, 1, 2] | |
| x-nullable: false | |
| ImageInspect: | |
| description: | | |
| Information about an image in the local image cache. | |
| type: "object" | |
| properties: | |
| Id: | |
| description: | | |
| ID is the content-addressable ID of an image. | |
| This identifier is a content-addressable digest calculated from the | |
| image's configuration (which includes the digests of layers used by | |
| the image). | |
| Note that this digest differs from the `RepoDigests` below, which | |
| holds digests of image manifests that reference the image. | |
| type: "string" | |
| x-nullable: false | |
| example: "sha256:ec3f0931a6e6b6855d76b2d7b0be30e81860baccd891b2e243280bf1cd8ad710" | |
| RepoTags: | |
| description: | | |
| List of image names/tags in the local image cache that reference this | |
| image. | |
| Multiple image tags can refer to the same image, and this list may be | |
| empty if no tags reference the image, in which case the image is | |
| "untagged", in which case it can still be referenced by its ID. | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "example:1.0" | |
| - "example:latest" | |
| - "example:stable" | |
| - "internal.registry.example.com:5000/example:1.0" | |
| RepoDigests: | |
| description: | | |
| List of content-addressable digests of locally available image manifests | |
| that the image is referenced from. Multiple manifests can refer to the | |
| same image. | |
| These digests are usually only available if the image was either pulled | |
| from a registry, or if the image was pushed to a registry, which is when | |
| the manifest is generated and its digest calculated. | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "example@sha256:afcc7f1ac1b49db317a7196c902e61c6c3c4607d63599ee1a82d702d249a0ccb" | |
| - "internal.registry.example.com:5000/example@sha256:b69959407d21e8a062e0416bf13405bb2b71ed7a84dde4158ebafacfa06f5578" | |
| Parent: | |
| description: | | |
| ID of the parent image. | |
| Depending on how the image was created, this field may be empty and | |
| is only set for images that were built/created locally. This field | |
| is empty if the image was pulled from an image registry. | |
| type: "string" | |
| x-nullable: false | |
| example: "" | |
| Comment: | |
| description: | | |
| Optional message that was set when committing or importing the image. | |
| type: "string" | |
| x-nullable: false | |
| example: "" | |
| Created: | |
| description: | | |
| Date and time at which the image was created, formatted in | |
| [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format with nano-seconds. | |
| type: "string" | |
| x-nullable: false | |
| example: "2022-02-04T21:20:12.497794809Z" | |
| Container: | |
| description: | | |
| The ID of the container that was used to create the image. | |
| Depending on how the image was created, this field may be empty. | |
| type: "string" | |
| x-nullable: false | |
| example: "65974bc86f1770ae4bff79f651ebdbce166ae9aada632ee3fa9af3a264911735" | |
| ContainerConfig: | |
| $ref: "#/definitions/ContainerConfig" | |
| DockerVersion: | |
| description: | | |
| The version of Docker that was used to build the image. | |
| Depending on how the image was created, this field may be empty. | |
| type: "string" | |
| x-nullable: false | |
| example: "20.10.7" | |
| Author: | |
| description: | | |
| Name of the author that was specified when committing the image, or as | |
| specified through MAINTAINER (deprecated) in the Dockerfile. | |
| type: "string" | |
| x-nullable: false | |
| example: "" | |
| Config: | |
| $ref: "#/definitions/ContainerConfig" | |
| Architecture: | |
| description: | | |
| Hardware CPU architecture that the image runs on. | |
| type: "string" | |
| x-nullable: false | |
| example: "arm" | |
| Variant: | |
| description: | | |
| CPU architecture variant (presently ARM-only). | |
| type: "string" | |
| x-nullable: true | |
| example: "v7" | |
| Os: | |
| description: | | |
| Operating System the image is built to run on. | |
| type: "string" | |
| x-nullable: false | |
| example: "linux" | |
| OsVersion: | |
| description: | | |
| Operating System version the image is built to run on (especially | |
| for Windows). | |
| type: "string" | |
| example: "" | |
| x-nullable: true | |
| Size: | |
| description: | | |
| Total size of the image including all layers it is composed of. | |
| type: "integer" | |
| format: "int64" | |
| x-nullable: false | |
| example: 1239828 | |
| VirtualSize: | |
| description: | | |
| Total size of the image including all layers it is composed of. | |
| In versions of Docker before v1.10, this field was calculated from | |
| the image itself and all of its parent images. Images are now stored | |
| self-contained, and no longer use a parent-chain, making this field | |
| an equivalent of the Size field. | |
| > **Deprecated**: this field is kept for backward compatibility, but | |
| > will be removed in API v1.44. | |
| type: "integer" | |
| format: "int64" | |
| example: 1239828 | |
| GraphDriver: | |
| $ref: "#/definitions/GraphDriverData" | |
| RootFS: | |
| description: | | |
| Information about the image's RootFS, including the layer IDs. | |
| type: "object" | |
| required: [Type] | |
| properties: | |
| Type: | |
| type: "string" | |
| x-nullable: false | |
| example: "layers" | |
| Layers: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "sha256:1834950e52ce4d5a88a1bbd131c537f4d0e56d10ff0dd69e66be3b7dfa9df7e6" | |
| - "sha256:5f70bf18a086007016e948b04aed3b82103a36bea41755b6cddfaf10ace3c6ef" | |
| Metadata: | |
| description: | | |
| Additional metadata of the image in the local cache. This information | |
| is local to the daemon, and not part of the image itself. | |
| type: "object" | |
| properties: | |
| LastTagTime: | |
| description: | | |
| Date and time at which the image was last tagged in | |
| [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format with nano-seconds. | |
| This information is only available if the image was tagged locally, | |
| and omitted otherwise. | |
| type: "string" | |
| format: "dateTime" | |
| example: "2022-02-28T14:40:02.623929178Z" | |
| x-nullable: true | |
| ImageSummary: | |
| type: "object" | |
| required: | |
| - Id | |
| - ParentId | |
| - RepoTags | |
| - RepoDigests | |
| - Created | |
| - Size | |
| - SharedSize | |
| - Labels | |
| - Containers | |
| properties: | |
| Id: | |
| description: | | |
| ID is the content-addressable ID of an image. | |
| This identifier is a content-addressable digest calculated from the | |
| image's configuration (which includes the digests of layers used by | |
| the image). | |
| Note that this digest differs from the `RepoDigests` below, which | |
| holds digests of image manifests that reference the image. | |
| type: "string" | |
| x-nullable: false | |
| example: "sha256:ec3f0931a6e6b6855d76b2d7b0be30e81860baccd891b2e243280bf1cd8ad710" | |
| ParentId: | |
| description: | | |
| ID of the parent image. | |
| Depending on how the image was created, this field may be empty and | |
| is only set for images that were built/created locally. This field | |
| is empty if the image was pulled from an image registry. | |
| type: "string" | |
| x-nullable: false | |
| example: "" | |
| RepoTags: | |
| description: | | |
| List of image names/tags in the local image cache that reference this | |
| image. | |
| Multiple image tags can refer to the same image, and this list may be | |
| empty if no tags reference the image, in which case the image is | |
| "untagged", in which case it can still be referenced by its ID. | |
| type: "array" | |
| x-nullable: false | |
| items: | |
| type: "string" | |
| example: | |
| - "example:1.0" | |
| - "example:latest" | |
| - "example:stable" | |
| - "internal.registry.example.com:5000/example:1.0" | |
| RepoDigests: | |
| description: | | |
| List of content-addressable digests of locally available image manifests | |
| that the image is referenced from. Multiple manifests can refer to the | |
| same image. | |
| These digests are usually only available if the image was either pulled | |
| from a registry, or if the image was pushed to a registry, which is when | |
| the manifest is generated and its digest calculated. | |
| type: "array" | |
| x-nullable: false | |
| items: | |
| type: "string" | |
| example: | |
| - "example@sha256:afcc7f1ac1b49db317a7196c902e61c6c3c4607d63599ee1a82d702d249a0ccb" | |
| - "internal.registry.example.com:5000/example@sha256:b69959407d21e8a062e0416bf13405bb2b71ed7a84dde4158ebafacfa06f5578" | |
| Created: | |
| description: | | |
| Date and time at which the image was created as a Unix timestamp | |
| (number of seconds sinds EPOCH). | |
| type: "integer" | |
| x-nullable: false | |
| example: "1644009612" | |
| Size: | |
| description: | | |
| Total size of the image including all layers it is composed of. | |
| type: "integer" | |
| format: "int64" | |
| x-nullable: false | |
| example: 172064416 | |
| SharedSize: | |
| description: | | |
| Total size of image layers that are shared between this image and other | |
| images. | |
| This size is not calculated by default. `-1` indicates that the value | |
| has not been set / calculated. | |
| type: "integer" | |
| format: "int64" | |
| x-nullable: false | |
| example: 1239828 | |
| VirtualSize: | |
| description: |- | |
| Total size of the image including all layers it is composed of. | |
| In versions of Docker before v1.10, this field was calculated from | |
| the image itself and all of its parent images. Images are now stored | |
| self-contained, and no longer use a parent-chain, making this field | |
| an equivalent of the Size field. | |
| Deprecated: this field is kept for backward compatibility, and will be removed in API v1.44. | |
| type: "integer" | |
| format: "int64" | |
| example: 172064416 | |
| Labels: | |
| description: "User-defined key/value metadata." | |
| type: "object" | |
| x-nullable: false | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| com.example.some-label: "some-value" | |
| com.example.some-other-label: "some-other-value" | |
| Containers: | |
| description: | | |
| Number of containers using this image. Includes both stopped and running | |
| containers. | |
| This size is not calculated by default, and depends on which API endpoint | |
| is used. `-1` indicates that the value has not been set / calculated. | |
| x-nullable: false | |
| type: "integer" | |
| example: 2 | |
| AuthConfig: | |
| type: "object" | |
| properties: | |
| username: | |
| type: "string" | |
| password: | |
| type: "string" | |
| email: | |
| type: "string" | |
| serveraddress: | |
| type: "string" | |
| example: | |
| username: "hannibal" | |
| password: "xxxx" | |
| serveraddress: "https://index.docker.io/v1/" | |
| ProcessConfig: | |
| type: "object" | |
| properties: | |
| privileged: | |
| type: "boolean" | |
| user: | |
| type: "string" | |
| tty: | |
| type: "boolean" | |
| entrypoint: | |
| type: "string" | |
| arguments: | |
| type: "array" | |
| items: | |
| type: "string" | |
| Volume: | |
| type: "object" | |
| required: [Name, Driver, Mountpoint, Labels, Scope, Options] | |
| properties: | |
| Name: | |
| type: "string" | |
| description: "Name of the volume." | |
| x-nullable: false | |
| example: "tardis" | |
| Driver: | |
| type: "string" | |
| description: "Name of the volume driver used by the volume." | |
| x-nullable: false | |
| example: "custom" | |
| Mountpoint: | |
| type: "string" | |
| description: "Mount path of the volume on the host." | |
| x-nullable: false | |
| example: "/var/lib/docker/volumes/tardis" | |
| CreatedAt: | |
| type: "string" | |
| format: "dateTime" | |
| description: "Date/Time the volume was created." | |
| example: "2016-06-07T20:31:11.853781916Z" | |
| Status: | |
| type: "object" | |
| description: | | |
| Low-level details about the volume, provided by the volume driver. | |
| Details are returned as a map with key/value pairs: | |
| `{"key":"value","key2":"value2"}`. | |
| The `Status` field is optional, and is omitted if the volume driver | |
| does not support this feature. | |
| additionalProperties: | |
| type: "object" | |
| example: | |
| hello: "world" | |
| Labels: | |
| type: "object" | |
| description: "User-defined key/value metadata." | |
| x-nullable: false | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| com.example.some-label: "some-value" | |
| com.example.some-other-label: "some-other-value" | |
| Scope: | |
| type: "string" | |
| description: | | |
| The level at which the volume exists. Either `global` for cluster-wide, | |
| or `local` for machine level. | |
| default: "local" | |
| x-nullable: false | |
| enum: ["local", "global"] | |
| example: "local" | |
| ClusterVolume: | |
| $ref: "#/definitions/ClusterVolume" | |
| Options: | |
| type: "object" | |
| description: | | |
| The driver specific options used when creating the volume. | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| device: "tmpfs" | |
| o: "size=100m,uid=1000" | |
| type: "tmpfs" | |
| UsageData: | |
| type: "object" | |
| x-nullable: true | |
| x-go-name: "UsageData" | |
| required: [Size, RefCount] | |
| description: | | |
| Usage details about the volume. This information is used by the | |
| `GET /system/df` endpoint, and omitted in other endpoints. | |
| properties: | |
| Size: | |
| type: "integer" | |
| format: "int64" | |
| default: -1 | |
| description: | | |
| Amount of disk space used by the volume (in bytes). This information | |
| is only available for volumes created with the `"local"` volume | |
| driver. For volumes created with other volume drivers, this field | |
| is set to `-1` ("not available") | |
| x-nullable: false | |
| RefCount: | |
| type: "integer" | |
| format: "int64" | |
| default: -1 | |
| description: | | |
| The number of containers referencing this volume. This field | |
| is set to `-1` if the reference-count is not available. | |
| x-nullable: false | |
| VolumeCreateOptions: | |
| description: "Volume configuration" | |
| type: "object" | |
| title: "VolumeConfig" | |
| x-go-name: "CreateOptions" | |
| properties: | |
| Name: | |
| description: | | |
| The new volume's name. If not specified, Docker generates a name. | |
| type: "string" | |
| x-nullable: false | |
| example: "tardis" | |
| Driver: | |
| description: "Name of the volume driver to use." | |
| type: "string" | |
| default: "local" | |
| x-nullable: false | |
| example: "custom" | |
| DriverOpts: | |
| description: | | |
| A mapping of driver options and values. These options are | |
| passed directly to the driver and are driver specific. | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| device: "tmpfs" | |
| o: "size=100m,uid=1000" | |
| type: "tmpfs" | |
| Labels: | |
| description: "User-defined key/value metadata." | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| com.example.some-label: "some-value" | |
| com.example.some-other-label: "some-other-value" | |
| ClusterVolumeSpec: | |
| $ref: "#/definitions/ClusterVolumeSpec" | |
| VolumeListResponse: | |
| type: "object" | |
| title: "VolumeListResponse" | |
| x-go-name: "ListResponse" | |
| description: "Volume list response" | |
| properties: | |
| Volumes: | |
| type: "array" | |
| description: "List of volumes" | |
| items: | |
| $ref: "#/definitions/Volume" | |
| Warnings: | |
| type: "array" | |
| description: | | |
| Warnings that occurred when fetching the list of volumes. | |
| items: | |
| type: "string" | |
| example: [] | |
| Network: | |
| type: "object" | |
| properties: | |
| Name: | |
| type: "string" | |
| Id: | |
| type: "string" | |
| Created: | |
| type: "string" | |
| format: "dateTime" | |
| Scope: | |
| type: "string" | |
| Driver: | |
| type: "string" | |
| EnableIPv6: | |
| type: "boolean" | |
| IPAM: | |
| $ref: "#/definitions/IPAM" | |
| Internal: | |
| type: "boolean" | |
| Attachable: | |
| type: "boolean" | |
| Ingress: | |
| type: "boolean" | |
| Containers: | |
| type: "object" | |
| additionalProperties: | |
| $ref: "#/definitions/NetworkContainer" | |
| Options: | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| Labels: | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| Name: "net01" | |
| Id: "7d86d31b1478e7cca9ebed7e73aa0fdeec46c5ca29497431d3007d2d9e15ed99" | |
| Created: "2016-10-19T04:33:30.360899459Z" | |
| Scope: "local" | |
| Driver: "bridge" | |
| EnableIPv6: false | |
| IPAM: | |
| Driver: "default" | |
| Config: | |
| - Subnet: "172.19.0.0/16" | |
| Gateway: "172.19.0.1" | |
| Options: | |
| foo: "bar" | |
| Internal: false | |
| Attachable: false | |
| Ingress: false | |
| Containers: | |
| 19a4d5d687db25203351ed79d478946f861258f018fe384f229f2efa4b23513c: | |
| Name: "test" | |
| EndpointID: "628cadb8bcb92de107b2a1e516cbffe463e321f548feb37697cce00ad694f21a" | |
| MacAddress: "02:42:ac:13:00:02" | |
| IPv4Address: "172.19.0.2/16" | |
| IPv6Address: "" | |
| Options: | |
| com.docker.network.bridge.default_bridge: "true" | |
| com.docker.network.bridge.enable_icc: "true" | |
| com.docker.network.bridge.enable_ip_masquerade: "true" | |
| com.docker.network.bridge.host_binding_ipv4: "0.0.0.0" | |
| com.docker.network.bridge.name: "docker0" | |
| com.docker.network.driver.mtu: "1500" | |
| Labels: | |
| com.example.some-label: "some-value" | |
| com.example.some-other-label: "some-other-value" | |
| IPAM: | |
| type: "object" | |
| properties: | |
| Driver: | |
| description: "Name of the IPAM driver to use." | |
| type: "string" | |
| default: "default" | |
| Config: | |
| description: | | |
| List of IPAM configuration options, specified as a map: | |
| ``` | |
| {"Subnet": <CIDR>, "IPRange": <CIDR>, "Gateway": <IP address>, "AuxAddress": <device_name:IP address>} | |
| ``` | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/IPAMConfig" | |
| Options: | |
| description: "Driver-specific options, specified as a map." | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| IPAMConfig: | |
| type: "object" | |
| properties: | |
| Subnet: | |
| type: "string" | |
| IPRange: | |
| type: "string" | |
| Gateway: | |
| type: "string" | |
| AuxiliaryAddresses: | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| NetworkContainer: | |
| type: "object" | |
| properties: | |
| Name: | |
| type: "string" | |
| EndpointID: | |
| type: "string" | |
| MacAddress: | |
| type: "string" | |
| IPv4Address: | |
| type: "string" | |
| IPv6Address: | |
| type: "string" | |
| BuildInfo: | |
| type: "object" | |
| properties: | |
| id: | |
| type: "string" | |
| stream: | |
| type: "string" | |
| error: | |
| type: "string" | |
| errorDetail: | |
| $ref: "#/definitions/ErrorDetail" | |
| status: | |
| type: "string" | |
| progress: | |
| type: "string" | |
| progressDetail: | |
| $ref: "#/definitions/ProgressDetail" | |
| aux: | |
| $ref: "#/definitions/ImageID" | |
| BuildCache: | |
| type: "object" | |
| description: | | |
| BuildCache contains information about a build cache record. | |
| properties: | |
| ID: | |
| type: "string" | |
| description: | | |
| Unique ID of the build cache record. | |
| example: "ndlpt0hhvkqcdfkputsk4cq9c" | |
| Parent: | |
| description: | | |
| ID of the parent build cache record. | |
| > **Deprecated**: This field is deprecated, and omitted if empty. | |
| type: "string" | |
| x-nullable: true | |
| example: "" | |
| Parents: | |
| description: | | |
| List of parent build cache record IDs. | |
| type: "array" | |
| items: | |
| type: "string" | |
| x-nullable: true | |
| example: ["hw53o5aio51xtltp5xjp8v7fx"] | |
| Type: | |
| type: "string" | |
| description: | | |
| Cache record type. | |
| example: "regular" | |
| # see https://github.com/moby/buildkit/blob/fce4a32258dc9d9664f71a4831d5de10f0670677/client/diskusage.go#L75-L84 | |
| enum: | |
| - "internal" | |
| - "frontend" | |
| - "source.local" | |
| - "source.git.checkout" | |
| - "exec.cachemount" | |
| - "regular" | |
| Description: | |
| type: "string" | |
| description: | | |
| Description of the build-step that produced the build cache. | |
| example: "mount / from exec /bin/sh -c echo 'Binary::apt::APT::Keep-Downloaded-Packages \"true\";' > /etc/apt/apt.conf.d/keep-cache" | |
| InUse: | |
| type: "boolean" | |
| description: | | |
| Indicates if the build cache is in use. | |
| example: false | |
| Shared: | |
| type: "boolean" | |
| description: | | |
| Indicates if the build cache is shared. | |
| example: true | |
| Size: | |
| description: | | |
| Amount of disk space used by the build cache (in bytes). | |
| type: "integer" | |
| example: 51 | |
| CreatedAt: | |
| description: | | |
| Date and time at which the build cache was created in | |
| [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format with nano-seconds. | |
| type: "string" | |
| format: "dateTime" | |
| example: "2016-08-18T10:44:24.496525531Z" | |
| LastUsedAt: | |
| description: | | |
| Date and time at which the build cache was last used in | |
| [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format with nano-seconds. | |
| type: "string" | |
| format: "dateTime" | |
| x-nullable: true | |
| example: "2017-08-09T07:09:37.632105588Z" | |
| UsageCount: | |
| type: "integer" | |
| example: 26 | |
| ImageID: | |
| type: "object" | |
| description: "Image ID or Digest" | |
| properties: | |
| ID: | |
| type: "string" | |
| example: | |
| ID: "sha256:85f05633ddc1c50679be2b16a0479ab6f7637f8884e0cfe0f4d20e1ebb3d6e7c" | |
| CreateImageInfo: | |
| type: "object" | |
| properties: | |
| id: | |
| type: "string" | |
| error: | |
| type: "string" | |
| errorDetail: | |
| $ref: "#/definitions/ErrorDetail" | |
| status: | |
| type: "string" | |
| progress: | |
| type: "string" | |
| progressDetail: | |
| $ref: "#/definitions/ProgressDetail" | |
| PushImageInfo: | |
| type: "object" | |
| properties: | |
| error: | |
| type: "string" | |
| status: | |
| type: "string" | |
| progress: | |
| type: "string" | |
| progressDetail: | |
| $ref: "#/definitions/ProgressDetail" | |
| ErrorDetail: | |
| type: "object" | |
| properties: | |
| code: | |
| type: "integer" | |
| message: | |
| type: "string" | |
| ProgressDetail: | |
| type: "object" | |
| properties: | |
| current: | |
| type: "integer" | |
| total: | |
| type: "integer" | |
| ErrorResponse: | |
| description: "Represents an error." | |
| type: "object" | |
| required: ["message"] | |
| properties: | |
| message: | |
| description: "The error message." | |
| type: "string" | |
| x-nullable: false | |
| example: | |
| message: "Something went wrong." | |
| IdResponse: | |
| description: "Response to an API call that returns just an Id" | |
| type: "object" | |
| required: ["Id"] | |
| properties: | |
| Id: | |
| description: "The id of the newly created object." | |
| type: "string" | |
| x-nullable: false | |
| EndpointSettings: | |
| description: "Configuration for a network endpoint." | |
| type: "object" | |
| properties: | |
| # Configurations | |
| IPAMConfig: | |
| $ref: "#/definitions/EndpointIPAMConfig" | |
| Links: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "container_1" | |
| - "container_2" | |
| Aliases: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "server_x" | |
| - "server_y" | |
| # Operational data | |
| NetworkID: | |
| description: | | |
| Unique ID of the network. | |
| type: "string" | |
| example: "08754567f1f40222263eab4102e1c733ae697e8e354aa9cd6e18d7402835292a" | |
| EndpointID: | |
| description: | | |
| Unique ID for the service endpoint in a Sandbox. | |
| type: "string" | |
| example: "b88f5b905aabf2893f3cbc4ee42d1ea7980bbc0a92e2c8922b1e1795298afb0b" | |
| Gateway: | |
| description: | | |
| Gateway address for this network. | |
| type: "string" | |
| example: "172.17.0.1" | |
| IPAddress: | |
| description: | | |
| IPv4 address. | |
| type: "string" | |
| example: "172.17.0.4" | |
| IPPrefixLen: | |
| description: | | |
| Mask length of the IPv4 address. | |
| type: "integer" | |
| example: 16 | |
| IPv6Gateway: | |
| description: | | |
| IPv6 gateway address. | |
| type: "string" | |
| example: "2001:db8:2::100" | |
| GlobalIPv6Address: | |
| description: | | |
| Global IPv6 address. | |
| type: "string" | |
| example: "2001:db8::5689" | |
| GlobalIPv6PrefixLen: | |
| description: | | |
| Mask length of the global IPv6 address. | |
| type: "integer" | |
| format: "int64" | |
| example: 64 | |
| MacAddress: | |
| description: | | |
| MAC address for the endpoint on this network. | |
| type: "string" | |
| example: "02:42:ac:11:00:04" | |
| DriverOpts: | |
| description: | | |
| DriverOpts is a mapping of driver options and values. These options | |
| are passed directly to the driver and are driver specific. | |
| type: "object" | |
| x-nullable: true | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| com.example.some-label: "some-value" | |
| com.example.some-other-label: "some-other-value" | |
| EndpointIPAMConfig: | |
| description: | | |
| EndpointIPAMConfig represents an endpoint's IPAM configuration. | |
| type: "object" | |
| x-nullable: true | |
| properties: | |
| IPv4Address: | |
| type: "string" | |
| example: "172.20.30.33" | |
| IPv6Address: | |
| type: "string" | |
| example: "2001:db8:abcd::3033" | |
| LinkLocalIPs: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "169.254.34.68" | |
| - "fe80::3468" | |
| PluginMount: | |
| type: "object" | |
| x-nullable: false | |
| required: [Name, Description, Settable, Source, Destination, Type, Options] | |
| properties: | |
| Name: | |
| type: "string" | |
| x-nullable: false | |
| example: "some-mount" | |
| Description: | |
| type: "string" | |
| x-nullable: false | |
| example: "This is a mount that's used by the plugin." | |
| Settable: | |
| type: "array" | |
| items: | |
| type: "string" | |
| Source: | |
| type: "string" | |
| example: "/var/lib/docker/plugins/" | |
| Destination: | |
| type: "string" | |
| x-nullable: false | |
| example: "/mnt/state" | |
| Type: | |
| type: "string" | |
| x-nullable: false | |
| example: "bind" | |
| Options: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "rbind" | |
| - "rw" | |
| PluginDevice: | |
| type: "object" | |
| required: [Name, Description, Settable, Path] | |
| x-nullable: false | |
| properties: | |
| Name: | |
| type: "string" | |
| x-nullable: false | |
| Description: | |
| type: "string" | |
| x-nullable: false | |
| Settable: | |
| type: "array" | |
| items: | |
| type: "string" | |
| Path: | |
| type: "string" | |
| example: "/dev/fuse" | |
| PluginEnv: | |
| type: "object" | |
| x-nullable: false | |
| required: [Name, Description, Settable, Value] | |
| properties: | |
| Name: | |
| x-nullable: false | |
| type: "string" | |
| Description: | |
| x-nullable: false | |
| type: "string" | |
| Settable: | |
| type: "array" | |
| items: | |
| type: "string" | |
| Value: | |
| type: "string" | |
| PluginInterfaceType: | |
| type: "object" | |
| x-nullable: false | |
| required: [Prefix, Capability, Version] | |
| properties: | |
| Prefix: | |
| type: "string" | |
| x-nullable: false | |
| Capability: | |
| type: "string" | |
| x-nullable: false | |
| Version: | |
| type: "string" | |
| x-nullable: false | |
| PluginPrivilege: | |
| description: | | |
| Describes a permission the user has to accept upon installing | |
| the plugin. | |
| type: "object" | |
| x-go-name: "PluginPrivilege" | |
| properties: | |
| Name: | |
| type: "string" | |
| example: "network" | |
| Description: | |
| type: "string" | |
| Value: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "host" | |
| Plugin: | |
| description: "A plugin for the Engine API" | |
| type: "object" | |
| required: [Settings, Enabled, Config, Name] | |
| properties: | |
| Id: | |
| type: "string" | |
| example: "5724e2c8652da337ab2eedd19fc6fc0ec908e4bd907c7421bf6a8dfc70c4c078" | |
| Name: | |
| type: "string" | |
| x-nullable: false | |
| example: "tiborvass/sample-volume-plugin" | |
| Enabled: | |
| description: | |
| True if the plugin is running. False if the plugin is not running, | |
| only installed. | |
| type: "boolean" | |
| x-nullable: false | |
| example: true | |
| Settings: | |
| description: "Settings that can be modified by users." | |
| type: "object" | |
| x-nullable: false | |
| required: [Args, Devices, Env, Mounts] | |
| properties: | |
| Mounts: | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/PluginMount" | |
| Env: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "DEBUG=0" | |
| Args: | |
| type: "array" | |
| items: | |
| type: "string" | |
| Devices: | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/PluginDevice" | |
| PluginReference: | |
| description: "plugin remote reference used to push/pull the plugin" | |
| type: "string" | |
| x-nullable: false | |
| example: "localhost:5000/tiborvass/sample-volume-plugin:latest" | |
| Config: | |
| description: "The config of a plugin." | |
| type: "object" | |
| x-nullable: false | |
| required: | |
| - Description | |
| - Documentation | |
| - Interface | |
| - Entrypoint | |
| - WorkDir | |
| - Network | |
| - Linux | |
| - PidHost | |
| - PropagatedMount | |
| - IpcHost | |
| - Mounts | |
| - Env | |
| - Args | |
| properties: | |
| DockerVersion: | |
| description: "Docker Version used to create the plugin" | |
| type: "string" | |
| x-nullable: false | |
| example: "17.06.0-ce" | |
| Description: | |
| type: "string" | |
| x-nullable: false | |
| example: "A sample volume plugin for Docker" | |
| Documentation: | |
| type: "string" | |
| x-nullable: false | |
| example: "https://docs.docker.com/engine/extend/plugins/" | |
| Interface: | |
| description: "The interface between Docker and the plugin" | |
| x-nullable: false | |
| type: "object" | |
| required: [Types, Socket] | |
| properties: | |
| Types: | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/PluginInterfaceType" | |
| example: | |
| - "docker.volumedriver/1.0" | |
| Socket: | |
| type: "string" | |
| x-nullable: false | |
| example: "plugins.sock" | |
| ProtocolScheme: | |
| type: "string" | |
| example: "some.protocol/v1.0" | |
| description: "Protocol to use for clients connecting to the plugin." | |
| enum: | |
| - "" | |
| - "moby.plugins.http/v1" | |
| Entrypoint: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "/usr/bin/sample-volume-plugin" | |
| - "/data" | |
| WorkDir: | |
| type: "string" | |
| x-nullable: false | |
| example: "/bin/" | |
| User: | |
| type: "object" | |
| x-nullable: false | |
| properties: | |
| UID: | |
| type: "integer" | |
| format: "uint32" | |
| example: 1000 | |
| GID: | |
| type: "integer" | |
| format: "uint32" | |
| example: 1000 | |
| Network: | |
| type: "object" | |
| x-nullable: false | |
| required: [Type] | |
| properties: | |
| Type: | |
| x-nullable: false | |
| type: "string" | |
| example: "host" | |
| Linux: | |
| type: "object" | |
| x-nullable: false | |
| required: [Capabilities, AllowAllDevices, Devices] | |
| properties: | |
| Capabilities: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "CAP_SYS_ADMIN" | |
| - "CAP_SYSLOG" | |
| AllowAllDevices: | |
| type: "boolean" | |
| x-nullable: false | |
| example: false | |
| Devices: | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/PluginDevice" | |
| PropagatedMount: | |
| type: "string" | |
| x-nullable: false | |
| example: "/mnt/volumes" | |
| IpcHost: | |
| type: "boolean" | |
| x-nullable: false | |
| example: false | |
| PidHost: | |
| type: "boolean" | |
| x-nullable: false | |
| example: false | |
| Mounts: | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/PluginMount" | |
| Env: | |
| type: "array" | |
| items: | |
| $ref: "#/definitions/PluginEnv" | |
| example: | |
| - Name: "DEBUG" | |
| Description: "If set, prints debug messages" | |
| Settable: null | |
| Value: "0" | |
| Args: | |
| type: "object" | |
| x-nullable: false | |
| required: [Name, Description, Settable, Value] | |
| properties: | |
| Name: | |
| x-nullable: false | |
| type: "string" | |
| example: "args" | |
| Description: | |
| x-nullable: false | |
| type: "string" | |
| example: "command line arguments" | |
| Settable: | |
| type: "array" | |
| items: | |
| type: "string" | |
| Value: | |
| type: "array" | |
| items: | |
| type: "string" | |
| rootfs: | |
| type: "object" | |
| properties: | |
| type: | |
| type: "string" | |
| example: "layers" | |
| diff_ids: | |
| type: "array" | |
| items: | |
| type: "string" | |
| example: | |
| - "sha256:675532206fbf3030b8458f88d6e26d4eb1577688a25efec97154c94e8b6b4887" | |
| - "sha256:e216a057b1cb1efc11f8a268f37ef62083e70b1b38323ba252e25ac88904a7e8" | |
| ObjectVersion: | |
| description: | | |
| The version number of the object such as node, service, etc. This is needed | |
| to avoid conflicting writes. The client must send the version number along | |
| with the modified specification when updating these objects. | |
| This approach ensures safe concurrency and determinism in that the change | |
| on the object may not be applied if the version number has changed from the | |
| last read. In other words, if two update requests specify the same base | |
| version, only one of the requests can succeed. As a result, two separate | |
| update requests that happen at the same time will not unintentionally | |
| overwrite each other. | |
| type: "object" | |
| properties: | |
| Index: | |
| type: "integer" | |
| format: "uint64" | |
| example: 373531 | |
| NodeSpec: | |
| type: "object" | |
| properties: | |
| Name: | |
| description: "Name for the node." | |
| type: "string" | |
| example: "my-node" | |
| Labels: | |
| description: "User-defined key/value metadata." | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| Role: | |
| description: "Role of the node." | |
| type: "string" | |
| enum: | |
| - "worker" | |
| - "manager" | |
| example: "manager" | |
| Availability: | |
| description: "Availability of the node." | |
| type: "string" | |
| enum: | |
| - "active" | |
| - "pause" | |
| - "drain" | |
| example: "active" | |
| example: | |
| Availability: "active" | |
| Name: "node-name" | |
| Role: "manager" | |
| Labels: | |
| foo: "bar" | |
| Node: | |
| type: "object" | |
| properties: | |
| ID: | |
| type: "string" | |
| example: "24ifsmvkjbyhk" | |
| Version: | |
| $ref: "#/definitions/ObjectVersion" | |
| CreatedAt: | |
| description: | | |
| Date and time at which the node was added to the swarm in | |
| [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format with nano-seconds. | |
| type: "string" | |
| format: "dateTime" | |
| example: "2016-08-18T10:44:24.496525531Z" | |
| UpdatedAt: | |
| description: | | |
| Date and time at which the node was last updated in | |
| [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format with nano-seconds. | |
| type: "string" | |
| format: "dateTime" | |
| example: "2017-08-09T07:09:37.632105588Z" | |
| Spec: | |
| $ref: "#/definitions/NodeSpec" | |
| Description: | |
| $ref: "#/definitions/NodeDescription" | |
| Status: | |
| $ref: "#/definitions/NodeStatus" | |
| ManagerStatus: | |
| $ref: "#/definitions/ManagerStatus" | |
| NodeDescription: | |
| description: | | |
| NodeDescription encapsulates the properties of the Node as reported by the | |
| agent. | |
| type: "object" | |
| properties: | |
| Hostname: | |
| type: "string" | |
| example: "bf3067039e47" | |
| Platform: | |
| $ref: "#/definitions/Platform" | |
| Resources: | |
| $ref: "#/definitions/ResourceObject" | |
| Engine: | |
| $ref: "#/definitions/EngineDescription" | |
| TLSInfo: | |
| $ref: "#/definitions/TLSInfo" | |
| Platform: | |
| description: | | |
| Platform represents the platform (Arch/OS). | |
| type: "object" | |
| properties: | |
| Architecture: | |
| description: | | |
| Architecture represents the hardware architecture (for example, | |
| `x86_64`). | |
| type: "string" | |
| example: "x86_64" | |
| OS: | |
| description: | | |
| OS represents the Operating System (for example, `linux` or `windows`). | |
| type: "string" | |
| example: "linux" | |
| EngineDescription: | |
| description: "EngineDescription provides information about an engine." | |
| type: "object" | |
| properties: | |
| EngineVersion: | |
| type: "string" | |
| example: "17.06.0" | |
| Labels: | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| foo: "bar" | |
| Plugins: | |
| type: "array" | |
| items: | |
| type: "object" | |
| properties: | |
| Type: | |
| type: "string" | |
| Name: | |
| type: "string" | |
| example: | |
| - Type: "Log" | |
| Name: "awslogs" | |
| - Type: "Log" | |
| Name: "fluentd" | |
| - Type: "Log" | |
| Name: "gcplogs" | |
| - Type: "Log" | |
| Name: "gelf" | |
| - Type: "Log" | |
| Name: "journald" | |
| - Type: "Log" | |
| Name: "json-file" | |
| - Type: "Log" | |
| Name: "splunk" | |
| - Type: "Log" | |
| Name: "syslog" | |
| - Type: "Network" | |
| Name: "bridge" | |
| - Type: "Network" | |
| Name: "host" | |
| - Type: "Network" | |
| Name: "ipvlan" | |
| - Type: "Network" | |
| Name: "macvlan" | |
| - Type: "Network" | |
| Name: "null" | |
| - Type: "Network" | |
| Name: "overlay" | |
| - Type: "Volume" | |
| Name: "local" | |
| - Type: "Volume" | |
| Name: "localhost:5000/vieux/sshfs:latest" | |
| - Type: "Volume" | |
| Name: "vieux/sshfs:latest" | |
| TLSInfo: | |
| description: | | |
| Information about the issuer of leaf TLS certificates and the trusted root | |
| CA certificate. | |
| type: "object" | |
| properties: | |
| TrustRoot: | |
| description: | | |
| The root CA certificate(s) that are used to validate leaf TLS | |
| certificates. | |
| type: "string" | |
| CertIssuerSubject: | |
| description: | |
| The base64-url-safe-encoded raw subject bytes of the issuer. | |
| type: "string" | |
| CertIssuerPublicKey: | |
| description: | | |
| The base64-url-safe-encoded raw public key bytes of the issuer. | |
| type: "string" | |
| example: | |
| TrustRoot: | | |
| -----BEGIN CERTIFICATE----- | |
| MIIBajCCARCgAwIBAgIUbYqrLSOSQHoxD8CwG6Bi2PJi9c8wCgYIKoZIzj0EAwIw | |
| EzERMA8GA1UEAxMIc3dhcm0tY2EwHhcNMTcwNDI0MjE0MzAwWhcNMzcwNDE5MjE0 | |
| MzAwWjATMREwDwYDVQQDEwhzd2FybS1jYTBZMBMGByqGSM49AgEGCCqGSM49AwEH | |
| A0IABJk/VyMPYdaqDXJb/VXh5n/1Yuv7iNrxV3Qb3l06XD46seovcDWs3IZNV1lf | |
| 3Skyr0ofcchipoiHkXBODojJydSjQjBAMA4GA1UdDwEB/wQEAwIBBjAPBgNVHRMB | |
| Af8EBTADAQH/MB0GA1UdDgQWBBRUXxuRcnFjDfR/RIAUQab8ZV/n4jAKBggqhkjO | |
| PQQDAgNIADBFAiAy+JTe6Uc3KyLCMiqGl2GyWGQqQDEcO3/YG36x7om65AIhAJvz | |
| pxv6zFeVEkAEEkqIYi0omA9+CjanB/6Bz4n1uw8H | |
| -----END CERTIFICATE----- | |
| CertIssuerSubject: "MBMxETAPBgNVBAMTCHN3YXJtLWNh" | |
| CertIssuerPublicKey: "MFkwEwYHKoZIzj0CAQYIKoZIzj0DAQcDQgAEmT9XIw9h1qoNclv9VeHmf/Vi6/uI2vFXdBveXTpcPjqx6i9wNazchk1XWV/dKTKvSh9xyGKmiIeRcE4OiMnJ1A==" | |
| NodeStatus: | |
| description: | | |
| NodeStatus represents the status of a node. | |
| It provides the current status of the node, as seen by the manager. | |
| type: "object" | |
| properties: | |
| State: | |
| $ref: "#/definitions/NodeState" | |
| Message: | |
| type: "string" | |
| example: "" | |
| Addr: | |
| description: "IP address of the node." | |
| type: "string" | |
| example: "172.17.0.2" | |
| NodeState: | |
| description: "NodeState represents the state of a node." | |
| type: "string" | |
| enum: | |
| - "unknown" | |
| - "down" | |
| - "ready" | |
| - "disconnected" | |
| example: "ready" | |
| ManagerStatus: | |
| description: | | |
| ManagerStatus represents the status of a manager. | |
| It provides the current status of a node's manager component, if the node | |
| is a manager. | |
| x-nullable: true | |
| type: "object" | |
| properties: | |
| Leader: | |
| type: "boolean" | |
| default: false | |
| example: true | |
| Reachability: | |
| $ref: "#/definitions/Reachability" | |
| Addr: | |
| description: | | |
| The IP address and port at which the manager is reachable. | |
| type: "string" | |
| example: "10.0.0.46:2377" | |
| Reachability: | |
| description: "Reachability represents the reachability of a node." | |
| type: "string" | |
| enum: | |
| - "unknown" | |
| - "unreachable" | |
| - "reachable" | |
| example: "reachable" | |
| SwarmSpec: | |
| description: "User modifiable swarm configuration." | |
| type: "object" | |
| properties: | |
| Name: | |
| description: "Name of the swarm." | |
| type: "string" | |
| example: "default" | |
| Labels: | |
| description: "User-defined key/value metadata." | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| com.example.corp.type: "production" | |
| com.example.corp.department: "engineering" | |
| Orchestration: | |
| description: "Orchestration configuration." | |
| type: "object" | |
| x-nullable: true | |
| properties: | |
| TaskHistoryRetentionLimit: | |
| description: | | |
| The number of historic tasks to keep per instance or node. If | |
| negative, never remove completed or failed tasks. | |
| type: "integer" | |
| format: "int64" | |
| example: 10 | |
| Raft: | |
| description: "Raft configuration." | |
| type: "object" | |
| properties: | |
| SnapshotInterval: | |
| description: "The number of log entries between snapshots." | |
| type: "integer" | |
| format: "uint64" | |
| example: 10000 | |
| KeepOldSnapshots: | |
| description: | | |
| The number of snapshots to keep beyond the current snapshot. | |
| type: "integer" | |
| format: "uint64" | |
| LogEntriesForSlowFollowers: | |
| description: | | |
| The number of log entries to keep around to sync up slow followers | |
| after a snapshot is created. | |
| type: "integer" | |
| format: "uint64" | |
| example: 500 | |
| ElectionTick: | |
| description: | | |
| The number of ticks that a follower will wait for a message from | |
| the leader before becoming a candidate and starting an election. | |
| `ElectionTick` must be greater than `HeartbeatTick`. | |
| A tick currently defaults to one second, so these translate | |
| directly to seconds currently, but this is NOT guaranteed. | |
| type: "integer" | |
| example: 3 | |
| HeartbeatTick: | |
| description: | | |
| The number of ticks between heartbeats. Every HeartbeatTick ticks, | |
| the leader will send a heartbeat to the followers. | |
| A tick currently defaults to one second, so these translate | |
| directly to seconds currently, but this is NOT guaranteed. | |
| type: "integer" | |
| example: 1 | |
| Dispatcher: | |
| description: "Dispatcher configuration." | |
| type: "object" | |
| x-nullable: true | |
| properties: | |
| HeartbeatPeriod: | |
| description: | | |
| The delay for an agent to send a heartbeat to the dispatcher. | |
| type: "integer" | |
| format: "int64" | |
| example: 5000000000 | |
| CAConfig: | |
| description: "CA configuration." | |
| type: "object" | |
| x-nullable: true | |
| properties: | |
| NodeCertExpiry: | |
| description: "The duration node certificates are issued for." | |
| type: "integer" | |
| format: "int64" | |
| example: 7776000000000000 | |
| ExternalCAs: | |
| description: | | |
| Configuration for forwarding signing requests to an external | |
| certificate authority. | |
| type: "array" | |
| items: | |
| type: "object" | |
| properties: | |
| Protocol: | |
| description: | | |
| Protocol for communication with the external CA (currently | |
| only `cfssl` is supported). | |
| type: "string" | |
| enum: | |
| - "cfssl" | |
| default: "cfssl" | |
| URL: | |
| description: | | |
| URL where certificate signing requests should be sent. | |
| type: "string" | |
| Options: | |
| description: | | |
| An object with key/value pairs that are interpreted as | |
| protocol-specific options for the external CA driver. | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| CACert: | |
| description: | | |
| The root CA certificate (in PEM format) this external CA uses | |
| to issue TLS certificates (assumed to be to the current swarm | |
| root CA certificate if not provided). | |
| type: "string" | |
| SigningCACert: | |
| description: | | |
| The desired signing CA certificate for all swarm node TLS leaf | |
| certificates, in PEM format. | |
| type: "string" | |
| SigningCAKey: | |
| description: | | |
| The desired signing CA key for all swarm node TLS leaf certificates, | |
| in PEM format. | |
| type: "string" | |
| ForceRotate: | |
| description: | | |
| An integer whose purpose is to force swarm to generate a new | |
| signing CA certificate and key, if none have been specified in | |
| `SigningCACert` and `SigningCAKey` | |
| format: "uint64" | |
| type: "integer" | |
| EncryptionConfig: | |
| description: "Parameters related to encryption-at-rest." | |
| type: "object" | |
| properties: | |
| AutoLockManagers: | |
| description: | | |
| If set, generate a key and use it to lock data stored on the | |
| managers. | |
| type: "boolean" | |
| example: false | |
| TaskDefaults: | |
| description: "Defaults for creating tasks in this cluster." | |
| type: "object" | |
| properties: | |
| LogDriver: | |
| description: | | |
| The log driver to use for tasks created in the orchestrator if | |
| unspecified by a service. | |
| Updating this value only affects new tasks. Existing tasks continue | |
| to use their previously configured log driver until recreated. | |
| type: "object" | |
| properties: | |
| Name: | |
| description: | | |
| The log driver to use as a default for new tasks. | |
| type: "string" | |
| example: "json-file" | |
| Options: | |
| description: | | |
| Driver-specific options for the selectd log driver, specified | |
| as key/value pairs. | |
| type: "object" | |
| additionalProperties: | |
| type: "string" | |
| example: | |
| "max-file": "10" | |
| "max-size": "100m" | |
| # The Swarm information for `GET /info`. It is the same as `GET /swarm`, but | |
| # without `JoinTokens`. | |
| ClusterInfo: | |
| description: | | |
| ClusterInfo represents information about the swarm as is returned by the | |
| "/info" endpoint. Join-tokens are not included. | |
| x-nullable: true | |
| type: "object" | |
| properties: | |
| ID: | |
| description: "The ID of the swarm." | |
| type: "string" | |
| example: "abajmipo7b4xz5ip2nrla6b11" | |
| Version: | |
| $ref: "#/definitions/ObjectVersion" | |
| CreatedAt: | |
| description: | | |
| Date and time at which the swarm was initialised in | |
| [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format with nano-seconds. | |
| type: "string" | |
| format: "dateTime" | |
| example: "2016-08-18T10:44:24.496525531Z" | |
| UpdatedAt: | |
| description: | | |
| Date and time at which the swarm was last updated in | |
| [RFC 3339](https://www.ietf.org/rfc/rfc3339.txt) format with nano-seconds. | |
| type: "string" | |
| format: "dateTime" | |
| example: "2017-08-09T07:09:37.632105588Z" | |
| Spec: | |
[...]
